#
# Copyright 2013-2018 Double Precision, Inc.
# See COPYING for distribution information.
#

%define libcxx_version %{expand:%(v="$LIBCXX_VERSION"; test "$v" = "" && v=0.22; echo $v)}

%{?compat: %define do_compat 1}
%{!?compat: %define do_compat 0}

%if %do_compat
Name: libcxxsql%{expand:%(echo 0.06cxx%{libcxx_version} | tr -d '.')}
%else
Name: libcxxsql
%endif

Summary: LibCXX SQL Library
Version: 0.6.0.%{libcxx_version}
Release: 1%{?extrarelease}
License: GPL
Group: Development/Libraries
Source0: libcxxsql-0.6.0.tar.bz2

%define _hardened_build 1

BuildRequires: libcxxbase-abi = %{libcxx_version}
BuildRequires: gmp-devel >= 5.1
BuildRequires: unixODBC-devel
BuildRequires: libidn-devel

%description
This package installs the LibCXX SQL library. This package must be installed
to run software that's linked against libcxxsql.

Some software may also need to need the unixODBC-gui-qt package, which
contains code for a GUI prompt to select an SQL data source, that some
applications use.

%package gmp
Group: Development/Libraries
Summary: LibCXX SQL support for the GNU MP library
Requires: %{name} = 0:%{version}-%{release}

%description gmp
This package installs an additional library that's needed to support
inserting and selecting libgmp's mpf_class values from an SQL database.

%package devel
Group: Development/Libraries
Summary: LibCXX SQL development libraries
Requires: %{name} = 0:%{version}-%{release}
Requires: %{name}-gmp = 0:%{version}-%{release}
Provides: libcxxsql-abi = 0.06

%description devel
This package installs files needed to develop applications that use
LibCXX SQL development libraries.

%prep
%setup -q -n libcxxsql-0.6.0
LIBCXX_VERSION=%libcxx_version %configure

%build
%{__make} %{_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install DESTDIR=$RPM_BUILD_ROOT
rm -f $RPM_BUILD_ROOT%{_libdir}/libcxxsql*/*.la

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%dir %{_libdir}/libcxxsql*
%{_libdir}/libcxxsql*/libcxxsql.so.*

%files gmp
%defattr(-,root,root,-)
%{_libdir}/libcxxsql*/libcxxsqldecimal.so.*

%files devel
%defattr(-,root,root,-)
%{_libdir}/libcxxsql*/*.so
%{_libdir}/libcxxsql*/*.a
%{_libdir}/pkgconfig/*
%{_includedir}/libcxxsql*
%{_datadir}/aclocal/*
%{_datadir}/libcxxsql*

%changelog
* Sat Sep 22 2018 Sam Varshavchik <mrsam@octopus.email-scan.com>
- New installation layout

* Mon Sep  2 2013 Sam Varshavchik <mrsam@octopus.email-scan.com>
- Put libcxxsqldecimal into a separate subpackage

* Sat Jun  1 2013 Sam Varshavchik <mrsam@octopus.email-scan.com>
- Initial version
