//! \file

// AUTOGENERATED -- do not edit

#include <x/ref.H>
#include <x/refiterator.H>
#include <x/sql/dbi/resultset.H>

// Forward declarations

namespace examples {
namespace example1 {
class accountsObj;
class accounts_JoinsObj;
class accountsBase;

class account_typesObj;
class account_types_JoinsObj;
class account_typesBase;


// Resultset classes and base classes

//! The \c accounts table resulset

typedef x::ref<accountsObj, accountsBase> accounts;

//! A constant reference to a \c accounts table resulset

typedef x::const_ref<accountsObj, accountsBase> const_accounts;

//! A nullable pointer reference to a \c accounts table resulset

typedef x::ptr<accountsObj, accountsBase> accountsptr;

//! A nullable pointer reference to a constant \c accounts table resulset

typedef x::const_ptr<accountsObj, accountsBase> const_accountsptr;


//! The \c account_types table resulset

typedef x::ref<account_typesObj, account_typesBase> account_types;

//! A constant reference to a \c account_types table resulset

typedef x::const_ref<account_typesObj, account_typesBase> const_account_types;

//! A nullable pointer reference to a \c account_types table resulset

typedef x::ptr<account_typesObj, account_typesBase> account_typesptr;

//! A nullable pointer reference to a constant \c account_types table resulset

typedef x::const_ptr<account_typesObj, account_typesBase> const_account_typesptr;


// Base classes

//! Base class for \c accounts resultsets

//! Refer to this class as accounts::base

class accountsBase : public x::ptrref_base {

public:

    class rowObj;

    class prefetchedrowObj;

    class iteratorObj;

    //! accounts::base::row - a reference to a row in the \c accountstable

    typedef x::ref<rowObj> row;

    //! accounts::base::rowptr - a nullable pointer reference to a row in the \c accountstable

    typedef x::ptr<rowObj> rowptr;

    //! accounts::base::const_row - a reference to a constant row in the \c accountstable

    typedef x::const_ref<rowObj> const_row;

    //! accounts::base::const_rowptr - a nullable pointer reference to a constant row in the \c accountstable

    typedef x::const_ptr<rowObj> const_rowptr;

//! accounts::base::iterator - Iterator returned by begin() and end() 

    typedef x::refiterator<iteratorObj> iterator;

//! accounts::base::iteratorptr - Nullable iterator value returned by begin() and end()

    typedef x::ptriterator<iteratorObj> iteratorptr;

//! accounts::base::const_iterator - Constant iterator value returned by begin() and end()

    typedef x::const_refiterator<iteratorObj> const_iterator;

//! accounts::base::const_iteratorptr - Nullable iterator value returned by begin() and end() 

    typedef x::const_ptriterator<iteratorObj> const_iteratorptr;

    //! accounts::base::joins - a reference to joins from the \c accountstable

    typedef x::ref<accounts_JoinsObj> joins;

    //! accounts::base::joinsptr - a nullable pointer reference to joins from the \c accountstable

    typedef x::ptr<accounts_JoinsObj> joinsptr;

    //! accounts::base::const_joins - a reference to constant joins from the \c accountstable

    typedef x::const_ref<accounts_JoinsObj> const_joins;

    //! accounts::base::const_joinsptr - a nullable pointer reference to constant joins from the \c accountstable

    typedef x::const_ptr<accounts_JoinsObj> const_joinsptr;

    //! A reference to a prefetched row.

    typedef x::ref<prefetchedrowObj> prefetchedrow;

    //! A nullable pointer reference to a prefetched row.

    typedef x::ptr<prefetchedrowObj> prefetchedrowptr;

    //! A reference to a constant prefetched row.

    typedef x::const_ref<prefetchedrowObj> const_prefetchedrow;

    //! A nullable pointer reference to a constant prefetched row.

    typedef x::ptr<prefetchedrowObj> const_prefetchedrowptr;
};


//! Base class for \c account_types resultsets

//! Refer to this class as account_types::base

class account_typesBase : public x::ptrref_base {

public:

    class rowObj;

    class prefetchedrowObj;

    class iteratorObj;

    //! account_types::base::row - a reference to a row in the \c account_typestable

    typedef x::ref<rowObj> row;

    //! account_types::base::rowptr - a nullable pointer reference to a row in the \c account_typestable

    typedef x::ptr<rowObj> rowptr;

    //! account_types::base::const_row - a reference to a constant row in the \c account_typestable

    typedef x::const_ref<rowObj> const_row;

    //! account_types::base::const_rowptr - a nullable pointer reference to a constant row in the \c account_typestable

    typedef x::const_ptr<rowObj> const_rowptr;

//! account_types::base::iterator - Iterator returned by begin() and end() 

    typedef x::refiterator<iteratorObj> iterator;

//! account_types::base::iteratorptr - Nullable iterator value returned by begin() and end()

    typedef x::ptriterator<iteratorObj> iteratorptr;

//! account_types::base::const_iterator - Constant iterator value returned by begin() and end()

    typedef x::const_refiterator<iteratorObj> const_iterator;

//! account_types::base::const_iteratorptr - Nullable iterator value returned by begin() and end() 

    typedef x::const_ptriterator<iteratorObj> const_iteratorptr;

    //! account_types::base::joins - a reference to joins from the \c account_typestable

    typedef x::ref<account_types_JoinsObj> joins;

    //! account_types::base::joinsptr - a nullable pointer reference to joins from the \c account_typestable

    typedef x::ptr<account_types_JoinsObj> joinsptr;

    //! account_types::base::const_joins - a reference to constant joins from the \c account_typestable

    typedef x::const_ref<account_types_JoinsObj> const_joins;

    //! account_types::base::const_joinsptr - a nullable pointer reference to constant joins from the \c account_typestable

    typedef x::const_ptr<account_types_JoinsObj> const_joinsptr;

    //! A reference to a prefetched row.

    typedef x::ref<prefetchedrowObj> prefetchedrow;

    //! A nullable pointer reference to a prefetched row.

    typedef x::ptr<prefetchedrowObj> prefetchedrowptr;

    //! A reference to a constant prefetched row.

    typedef x::const_ref<prefetchedrowObj> const_prefetchedrow;

    //! A nullable pointer reference to a constant prefetched row.

    typedef x::ptr<prefetchedrowObj> const_prefetchedrowptr;
};

//! Joins for the \c accounts resultset object

class accounts_JoinsObj : public x::sql::dbi::joinBaseObj {

public:

    //! The table columns

    static const char * const columns[];

    //! Return table columns

    const char * const *get_table_columns() const override;

    

    //! Constructor

    accounts_JoinsObj();

    //! Destructor

    ~accounts_JoinsObj() noexcept;


    //! Create a join to the account_types table on columns: account_type_id
    virtual account_types::base::joins join_account_types()=0;


    //! Prefetch rows from this join

    accounts::base::prefetchedrow prefetch();

private:

    //! Return the connection object that was used to create this join.

    //! Used by prefetch() to retrieve the connection object from the subclass
    //! so that it can instantiated the prefetchedrow object.

    virtual x::sql::connection getConnection()=0;
};

//! The \c accounts resultset object

class accountsObj : public x::sql::dbi::resultsetObj, public accounts_JoinsObj {

//! The table alias in the resultset

    std::string alias;

public:

    //! Resultset constructor

    accountsObj(const x::sql::connection &conn);

    //! Additional resultset constructed by a join

    accountsObj(const x::sql::connection &conn, const x::ref<aliasesObj> &aliasesArg);

    //! Destructor
    
    ~accountsObj() noexcept;

private:
    //! This table's name

    static const char table_name[];

public:
    //! Return this table's name;

    const char *get_table_name() const override;

    //! This table's alias

    std::string get_table_alias() const override;

    //! Table's primary keys

    static const char * const primarykeycolumns[];

    //! Return table's primary key columns

    const char * const *get_primary_key_columns() const override;

    //! Table's serial keys

    static const char * const serialkeycolumns[];

    //! Return table's serial primary key column(s)

    const char * const *get_serial_key_columns() const override;

    friend class accountsBase::rowObj;

    friend class accountsBase::iteratorObj;

    //! Convenience typedef

    typedef accountsBase::iterator iterator;

    //! Convenience typedef

    typedef accountsBase::iteratorptr iteratorptr;

    //! Convenience typedef

    typedef accountsBase::const_iterator const_iterator;

    //! Convenience typedef

    typedef accountsBase::const_iteratorptr const_iteratorptr;

    //! Convenience typedef

    typedef accountsBase::row row;

    //! Convenience typedef

    typedef accountsBase::rowptr rowptr;

    //! Convenience typedef

    typedef accountsBase::const_row const_row;

    //! Convenience typedef

    typedef accountsBase::const_rowptr const_rowptr;

    //! Execute a SELECT on this resultset, return the beginning iterator for the sequence.

    //! The maximum number of rows is set by calling limit(), previously.
    iterator begin() const;

    //! Execute a SELECT on this resultset, return the beginning iterator for the sequence.

    //! The maximum number of rows is given explicitly
    iterator begin(size_t limitvalue) const;

    //! Return ending iterator value for a SELECT sequence

    iterator end() const;

    //! Return the sole row possibly expected from a SELECT on this resultset.

    //! Uses begin(2), and throws an exception if the SELECT returns a second
    //! row. Returns a null pointer reference if SELECT returned no rows.

    rowptr maybe() const;

    //! Return the sole row definitely expected from a SELECT on this resultset.

    //! Calls maybe(), and throws an exception if maybe() returns an empty
    //! pointer.

    row only() const;

private:

    //! Resultset implementation subclass forwards this to its create_column_list()

    void resultset_create_column_list(std::vector<std::string> &columns) const override;

    //! Add additional joins to the resultset

    //! Used by get_search_sql() to recursively add joins to joins.

    void get_join_sql_recursive(std::ostream &) const override;

    //! Invoke join_prefetch_column_list()

    void prefetch_column_list_recursive(std::vector<std::string> &list) const override;

    //! Invoke join_bind_prefetched_row()
    void bind_prefetched_recursive(std::vector<x::sql::bindrowimpl> &list) const override;
public:

    //! Used by prefetch() to retrieve the connection object.

    x::sql::connection getConnection() override;

    //! Insert a new row

    template<typename ...Args>
    inline row insert(Args && ...args)
    {
        auto rs=accounts::create(conn);

	auto insert_constraints=x::ref<x::sql::dbi::constraintObj::andObj>::create();

        {
            auto values=x::ref<x::sql::dbi::constraintObj::andObj>::create();

            x::sql::dbi::get_updins_list(values, std::forward<Args>(args)...);

            do_insert(rs->insert_sql, insert_constraints, rs->where, values);
        }

	rs->insert_select_constraint=insert_constraints;
        return rs->only();
    }


    //! Create a join to the account_types table on columns: account_type_id
    account_types::base::joins join_account_types() override;

};

//! A reference-counted object representing a row in this table

class accountsBase::rowObj : public x::sql::dbi::resultsetObj::rowObj {

public:

    friend class iteratorObj;

    //! Constructor

    rowObj(const x::sql::connection &conn);

    //! Destructor

    ~rowObj() noexcept;

//! Column

    x::sql::dbi::resultsetObj::rowObj::field<int64_t> account_id;

//! Column

    x::sql::dbi::resultsetObj::rowObj::field<int64_t> account_type_id;

//! Column

    x::sql::dbi::resultsetObj::rowObj::field<std::string> name;

//! Column

    x::sql::dbi::resultsetObj::rowObj::field<double> balance;


    //! Create a new resultset based on a join to the account_types table on columns: account_type_id
    account_types join_rs_account_types() const;

    //! Retrieve the only row possibly expected from a join to the account_types table on columns: account_type_id

    account_types::base::rowptr join_maybe_account_types() const;

    //! Retrieve the only row definitely from a join to the account_types table on columns: account_type_id

    account_types::base::row join_only_account_types() const;

      //! Execute the join to the account_types table on columns: account_type_id

    inline account_types join_account_types() const
    {
        return join_rs_account_types();
    }

private:

    //! Cached joined row

    mutable x::sql::dbi::resultsetObj::rowObj::cached_row<account_types::base::rowptr> join_row_account_types;

public:


    //! Update this row

    //! Returns true if the row was updated, false if the row was unchanged.
    //! An exception gets thrown if the schema's primary keys are wrong.

    bool update() override;

    friend class accountsBase::prefetchedrowObj;

private:
    //! This row has been fetched. Preserve all .scalar in .original

    void fetched_this_row();
};

//! A new row factory, used by iteratorObj to create new rows.

//! Also returned by join handles' prefetch(), where a prefetched row may be
//! retrieved from.

class accountsBase::prefetchedrowObj : public x::sql::bindrowimplObj {

    //! Our omniscient connection

    x::sql::connection conn;

    //! The next row being fetched

    accounts::base::row next_row;

    //! Whether next_row has been used, or not.

    //! The constructor creates a new next_row. First call to bind() uses
    //! it, subsequent calls create a new next_row.

    bool first;

public:

    //! Current row

    accounts::base::row row;

    friend class iteratorObj;

    friend class accounts_JoinObj;

public:
    //! Constructor
    prefetchedrowObj(const x::sql::connection &connArg);

    //! Destructor
    ~prefetchedrowObj() noexcept;

private:

    //! Bind next row
    void bind(x::sql::bindrow::consecutive &factory) override;

    //! The row was fetched
    void fetched() override;
};


//! A reference-counted iterator object, over the resultset

class accountsBase::iteratorObj : virtual public x::obj {

    //! Current row

    x::ref<accounts::base::prefetchedrowObj> current_row;

    //! All rows, this one and any prefetched ones.

    x::sql::dbi::resultsetObj::bindrow_all all_rows;

    //! The executed SELECT statement

    x::sql::statementptr statement;

    //! The resultset this iterator came from

    
    const_accounts resultset;

public:
    friend class accountsObj;

    //! This is an input iterator

    typedef std::input_iterator_tag iterator_category;

    //! What this is iterating over

    typedef accounts::base::row value_type;

    //! Iterator trait
    typedef std::ptrdiff_t difference_type;

    //! Iterator trait
    typedef value_type *pointer;

    //! Iterator trait
    typedef value_type &reference;

public:
    //! Beginning iterator constructor

    //! The resultset's begin() create()s this object using this constructor.
    //! We get the executed statement object, and the resultset that created
    //! this iterator.

    iteratorObj(const x::sql::statement &statementArg, const const_accounts &resultsetArg);

    //! Ending iterator constructor

    //! The resultset's end() create()s this object using this constructor.

    iteratorObj(const 
    const_accounts &resultsetArg);

    //! Destructor

    ~iteratorObj() noexcept;

    //! The * operator

    inline const accounts::base::row &operator*() const
    {
        *statement; // Ending iterator value check.
        return current_row->row;
    }

    //! Fetch next row

    void operator++()
    {
        if (!statement->fetch(all_rows))
        {
            // No more rows
            statement=x::sql::statementptr();
            return;
        }

        for (const auto &row:all_rows.rows)
            row->fetched();
    }

    //! Two ending iterator values compare equal, anything else doesn't

    inline bool operator==(const iteratorObj &o) const
    {
        return statement.null() && o.statement.null();
    }

    //! Two ending iterator values compare equal, anything else doesn't

    inline bool operator!=(const iteratorObj &o) const
    {
        return !operator==(o);
    }

private:

    //! Helper class used by before_postoper()
    class postoper_helper {

        //! Saved row

        accounts::base::row saved_row;

    public:
        //! Constructor
        inline postoper_helper(const accounts::base::row & saved_rowArg) : saved_row(saved_rowArg) {}

        
        inline accounts::base::row operator*() const { return saved_row; }
    };

public:
    //! Called by refobjiterator's postfix++ before it calls my operator++()

    postoper_helper before_postoper();
};

//! Joins for the \c account_types resultset object

class account_types_JoinsObj : public x::sql::dbi::joinBaseObj {

public:

    //! The table columns

    static const char * const columns[];

    //! Return table columns

    const char * const *get_table_columns() const override;

    

    //! Constructor

    account_types_JoinsObj();

    //! Destructor

    ~account_types_JoinsObj() noexcept;


    //! Prefetch rows from this join

    account_types::base::prefetchedrow prefetch();

private:

    //! Return the connection object that was used to create this join.

    //! Used by prefetch() to retrieve the connection object from the subclass
    //! so that it can instantiated the prefetchedrow object.

    virtual x::sql::connection getConnection()=0;
};

//! The \c account_types resultset object

class account_typesObj : public x::sql::dbi::resultsetObj, public account_types_JoinsObj {

//! The table alias in the resultset

    std::string alias;

public:

    //! Resultset constructor

    account_typesObj(const x::sql::connection &conn);

    //! Additional resultset constructed by a join

    account_typesObj(const x::sql::connection &conn, const x::ref<aliasesObj> &aliasesArg);

    //! Destructor
    
    ~account_typesObj() noexcept;

private:
    //! This table's name

    static const char table_name[];

public:
    //! Return this table's name;

    const char *get_table_name() const override;

    //! This table's alias

    std::string get_table_alias() const override;

    //! Table's primary keys

    static const char * const primarykeycolumns[];

    //! Return table's primary key columns

    const char * const *get_primary_key_columns() const override;

    //! Table's serial keys

    static const char * const serialkeycolumns[];

    //! Return table's serial primary key column(s)

    const char * const *get_serial_key_columns() const override;

    friend class account_typesBase::rowObj;

    friend class account_typesBase::iteratorObj;

    //! Convenience typedef

    typedef account_typesBase::iterator iterator;

    //! Convenience typedef

    typedef account_typesBase::iteratorptr iteratorptr;

    //! Convenience typedef

    typedef account_typesBase::const_iterator const_iterator;

    //! Convenience typedef

    typedef account_typesBase::const_iteratorptr const_iteratorptr;

    //! Convenience typedef

    typedef account_typesBase::row row;

    //! Convenience typedef

    typedef account_typesBase::rowptr rowptr;

    //! Convenience typedef

    typedef account_typesBase::const_row const_row;

    //! Convenience typedef

    typedef account_typesBase::const_rowptr const_rowptr;

    //! Execute a SELECT on this resultset, return the beginning iterator for the sequence.

    //! The maximum number of rows is set by calling limit(), previously.
    iterator begin() const;

    //! Execute a SELECT on this resultset, return the beginning iterator for the sequence.

    //! The maximum number of rows is given explicitly
    iterator begin(size_t limitvalue) const;

    //! Return ending iterator value for a SELECT sequence

    iterator end() const;

    //! Return the sole row possibly expected from a SELECT on this resultset.

    //! Uses begin(2), and throws an exception if the SELECT returns a second
    //! row. Returns a null pointer reference if SELECT returned no rows.

    rowptr maybe() const;

    //! Return the sole row definitely expected from a SELECT on this resultset.

    //! Calls maybe(), and throws an exception if maybe() returns an empty
    //! pointer.

    row only() const;

private:

    //! Resultset implementation subclass forwards this to its create_column_list()

    void resultset_create_column_list(std::vector<std::string> &columns) const override;

    //! Add additional joins to the resultset

    //! Used by get_search_sql() to recursively add joins to joins.

    void get_join_sql_recursive(std::ostream &) const override;

    //! Invoke join_prefetch_column_list()

    void prefetch_column_list_recursive(std::vector<std::string> &list) const override;

    //! Invoke join_bind_prefetched_row()
    void bind_prefetched_recursive(std::vector<x::sql::bindrowimpl> &list) const override;
public:

    //! Used by prefetch() to retrieve the connection object.

    x::sql::connection getConnection() override;

    //! Insert a new row

    template<typename ...Args>
    inline row insert(Args && ...args)
    {
        auto rs=account_types::create(conn);

	auto insert_constraints=x::ref<x::sql::dbi::constraintObj::andObj>::create();

        {
            auto values=x::ref<x::sql::dbi::constraintObj::andObj>::create();

            x::sql::dbi::get_updins_list(values, std::forward<Args>(args)...);

            do_insert(rs->insert_sql, insert_constraints, rs->where, values);
        }

	rs->insert_select_constraint=insert_constraints;
        return rs->only();
    }

};

//! A reference-counted object representing a row in this table

class account_typesBase::rowObj : public x::sql::dbi::resultsetObj::rowObj {

public:

    friend class iteratorObj;

    //! Constructor

    rowObj(const x::sql::connection &conn);

    //! Destructor

    ~rowObj() noexcept;

//! Column

    x::sql::dbi::resultsetObj::rowObj::field<int64_t> account_type_id;

//! Column

    x::sql::dbi::resultsetObj::rowObj::field<std::string> name;


    //! Update this row

    //! Returns true if the row was updated, false if the row was unchanged.
    //! An exception gets thrown if the schema's primary keys are wrong.

    bool update() override;

    friend class account_typesBase::prefetchedrowObj;

private:
    //! This row has been fetched. Preserve all .scalar in .original

    void fetched_this_row();
};

//! A new row factory, used by iteratorObj to create new rows.

//! Also returned by join handles' prefetch(), where a prefetched row may be
//! retrieved from.

class account_typesBase::prefetchedrowObj : public x::sql::bindrowimplObj {

    //! Our omniscient connection

    x::sql::connection conn;

    //! The next row being fetched

    account_types::base::row next_row;

    //! Whether next_row has been used, or not.

    //! The constructor creates a new next_row. First call to bind() uses
    //! it, subsequent calls create a new next_row.

    bool first;

public:

    //! Current row

    account_types::base::row row;

    friend class iteratorObj;

    friend class account_types_JoinObj;

public:
    //! Constructor
    prefetchedrowObj(const x::sql::connection &connArg);

    //! Destructor
    ~prefetchedrowObj() noexcept;

private:

    //! Bind next row
    void bind(x::sql::bindrow::consecutive &factory) override;

    //! The row was fetched
    void fetched() override;
};


//! A reference-counted iterator object, over the resultset

class account_typesBase::iteratorObj : virtual public x::obj {

    //! Current row

    x::ref<account_types::base::prefetchedrowObj> current_row;

    //! All rows, this one and any prefetched ones.

    x::sql::dbi::resultsetObj::bindrow_all all_rows;

    //! The executed SELECT statement

    x::sql::statementptr statement;

    //! The resultset this iterator came from

    
    const_account_types resultset;

public:
    friend class account_typesObj;

    //! This is an input iterator

    typedef std::input_iterator_tag iterator_category;

    //! What this is iterating over

    typedef account_types::base::row value_type;

    //! Iterator trait
    typedef std::ptrdiff_t difference_type;

    //! Iterator trait
    typedef value_type *pointer;

    //! Iterator trait
    typedef value_type &reference;

public:
    //! Beginning iterator constructor

    //! The resultset's begin() create()s this object using this constructor.
    //! We get the executed statement object, and the resultset that created
    //! this iterator.

    iteratorObj(const x::sql::statement &statementArg, const const_account_types &resultsetArg);

    //! Ending iterator constructor

    //! The resultset's end() create()s this object using this constructor.

    iteratorObj(const 
    const_account_types &resultsetArg);

    //! Destructor

    ~iteratorObj() noexcept;

    //! The * operator

    inline const account_types::base::row &operator*() const
    {
        *statement; // Ending iterator value check.
        return current_row->row;
    }

    //! Fetch next row

    void operator++()
    {
        if (!statement->fetch(all_rows))
        {
            // No more rows
            statement=x::sql::statementptr();
            return;
        }

        for (const auto &row:all_rows.rows)
            row->fetched();
    }

    //! Two ending iterator values compare equal, anything else doesn't

    inline bool operator==(const iteratorObj &o) const
    {
        return statement.null() && o.statement.null();
    }

    //! Two ending iterator values compare equal, anything else doesn't

    inline bool operator!=(const iteratorObj &o) const
    {
        return !operator==(o);
    }

private:

    //! Helper class used by before_postoper()
    class postoper_helper {

        //! Saved row

        account_types::base::row saved_row;

    public:
        //! Constructor
        inline postoper_helper(const account_types::base::row & saved_rowArg) : saved_row(saved_rowArg) {}

        
        inline account_types::base::row operator*() const { return saved_row; }
    };

public:
    //! Called by refobjiterator's postfix++ before it calls my operator++()

    postoper_helper before_postoper();
};

};
};
