//! \file

// AUTOGENERATED -- do not edit

#include <x/ref.H>
#include <x/refiterator.H>
#include <x/sql/dbi/resultset.H>

// Forward declarations

namespace example3 {
class accountsObj;
class accounts_JoinsObj;
class accountsBase;

class transactionsObj;
class transactions_JoinsObj;
class transactionsBase;

class ledger_entriesObj;
class ledger_entries_JoinsObj;
class ledger_entriesBase;


// Resultset classes and base classes

//! The \c accounts table resulset

typedef x::ref<accountsObj, accountsBase> accounts;

//! A constant reference to a \c accounts table resulset

typedef x::const_ref<accountsObj, accountsBase> const_accounts;

//! A nullable pointer reference to a \c accounts table resulset

typedef x::ptr<accountsObj, accountsBase> accountsptr;

//! A nullable pointer reference to a constant \c accounts table resulset

typedef x::const_ptr<accountsObj, accountsBase> const_accountsptr;


//! The \c transactions table resulset

typedef x::ref<transactionsObj, transactionsBase> transactions;

//! A constant reference to a \c transactions table resulset

typedef x::const_ref<transactionsObj, transactionsBase> const_transactions;

//! A nullable pointer reference to a \c transactions table resulset

typedef x::ptr<transactionsObj, transactionsBase> transactionsptr;

//! A nullable pointer reference to a constant \c transactions table resulset

typedef x::const_ptr<transactionsObj, transactionsBase> const_transactionsptr;


//! The \c ledger_entries table resulset

typedef x::ref<ledger_entriesObj, ledger_entriesBase> ledger_entries;

//! A constant reference to a \c ledger_entries table resulset

typedef x::const_ref<ledger_entriesObj, ledger_entriesBase> const_ledger_entries;

//! A nullable pointer reference to a \c ledger_entries table resulset

typedef x::ptr<ledger_entriesObj, ledger_entriesBase> ledger_entriesptr;

//! A nullable pointer reference to a constant \c ledger_entries table resulset

typedef x::const_ptr<ledger_entriesObj, ledger_entriesBase> const_ledger_entriesptr;


// Base classes

//! Base class for \c accounts resultsets

//! Refer to this class as accounts::base

class accountsBase : public x::ptrref_base {

public:

    class rowObj;

    class prefetchedrowObj;

    class iteratorObj;

    //! accounts::base::row - a reference to a row in the \c temptbl_accountstable

    typedef x::ref<rowObj> row;

    //! accounts::base::rowptr - a nullable pointer reference to a row in the \c temptbl_accountstable

    typedef x::ptr<rowObj> rowptr;

    //! accounts::base::const_row - a reference to a constant row in the \c temptbl_accountstable

    typedef x::const_ref<rowObj> const_row;

    //! accounts::base::const_rowptr - a nullable pointer reference to a constant row in the \c temptbl_accountstable

    typedef x::const_ptr<rowObj> const_rowptr;

//! accounts::base::iterator - Iterator returned by begin() and end() 

    typedef x::refiterator<iteratorObj> iterator;

//! accounts::base::iteratorptr - Nullable iterator value returned by begin() and end()

    typedef x::ptriterator<iteratorObj> iteratorptr;

//! accounts::base::const_iterator - Constant iterator value returned by begin() and end()

    typedef x::const_refiterator<iteratorObj> const_iterator;

//! accounts::base::const_iteratorptr - Nullable iterator value returned by begin() and end() 

    typedef x::const_ptriterator<iteratorObj> const_iteratorptr;

    //! accounts::base::joins - a reference to joins from the \c temptbl_accountstable

    typedef x::ref<accounts_JoinsObj> joins;

    //! accounts::base::joinsptr - a nullable pointer reference to joins from the \c temptbl_accountstable

    typedef x::ptr<accounts_JoinsObj> joinsptr;

    //! accounts::base::const_joins - a reference to constant joins from the \c temptbl_accountstable

    typedef x::const_ref<accounts_JoinsObj> const_joins;

    //! accounts::base::const_joinsptr - a nullable pointer reference to constant joins from the \c temptbl_accountstable

    typedef x::const_ptr<accounts_JoinsObj> const_joinsptr;

    //! A reference to a prefetched row.

    typedef x::ref<prefetchedrowObj> prefetchedrow;

    //! A nullable pointer reference to a prefetched row.

    typedef x::ptr<prefetchedrowObj> prefetchedrowptr;

    //! A reference to a constant prefetched row.

    typedef x::const_ref<prefetchedrowObj> const_prefetchedrow;

    //! A nullable pointer reference to a constant prefetched row.

    typedef x::ptr<prefetchedrowObj> const_prefetchedrowptr;
};


//! Base class for \c transactions resultsets

//! Refer to this class as transactions::base

class transactionsBase : public x::ptrref_base {

public:

    class rowObj;

    class prefetchedrowObj;

    class iteratorObj;

    //! transactions::base::row - a reference to a row in the \c temptbl_transactionstable

    typedef x::ref<rowObj> row;

    //! transactions::base::rowptr - a nullable pointer reference to a row in the \c temptbl_transactionstable

    typedef x::ptr<rowObj> rowptr;

    //! transactions::base::const_row - a reference to a constant row in the \c temptbl_transactionstable

    typedef x::const_ref<rowObj> const_row;

    //! transactions::base::const_rowptr - a nullable pointer reference to a constant row in the \c temptbl_transactionstable

    typedef x::const_ptr<rowObj> const_rowptr;

//! transactions::base::iterator - Iterator returned by begin() and end() 

    typedef x::refiterator<iteratorObj> iterator;

//! transactions::base::iteratorptr - Nullable iterator value returned by begin() and end()

    typedef x::ptriterator<iteratorObj> iteratorptr;

//! transactions::base::const_iterator - Constant iterator value returned by begin() and end()

    typedef x::const_refiterator<iteratorObj> const_iterator;

//! transactions::base::const_iteratorptr - Nullable iterator value returned by begin() and end() 

    typedef x::const_ptriterator<iteratorObj> const_iteratorptr;

    //! transactions::base::joins - a reference to joins from the \c temptbl_transactionstable

    typedef x::ref<transactions_JoinsObj> joins;

    //! transactions::base::joinsptr - a nullable pointer reference to joins from the \c temptbl_transactionstable

    typedef x::ptr<transactions_JoinsObj> joinsptr;

    //! transactions::base::const_joins - a reference to constant joins from the \c temptbl_transactionstable

    typedef x::const_ref<transactions_JoinsObj> const_joins;

    //! transactions::base::const_joinsptr - a nullable pointer reference to constant joins from the \c temptbl_transactionstable

    typedef x::const_ptr<transactions_JoinsObj> const_joinsptr;

    //! A reference to a prefetched row.

    typedef x::ref<prefetchedrowObj> prefetchedrow;

    //! A nullable pointer reference to a prefetched row.

    typedef x::ptr<prefetchedrowObj> prefetchedrowptr;

    //! A reference to a constant prefetched row.

    typedef x::const_ref<prefetchedrowObj> const_prefetchedrow;

    //! A nullable pointer reference to a constant prefetched row.

    typedef x::ptr<prefetchedrowObj> const_prefetchedrowptr;
};


//! Base class for \c ledger_entries resultsets

//! Refer to this class as ledger_entries::base

class ledger_entriesBase : public x::ptrref_base {

public:

    class rowObj;

    class prefetchedrowObj;

    class iteratorObj;

    //! ledger_entries::base::row - a reference to a row in the \c temptbl_ledger_entriestable

    typedef x::ref<rowObj> row;

    //! ledger_entries::base::rowptr - a nullable pointer reference to a row in the \c temptbl_ledger_entriestable

    typedef x::ptr<rowObj> rowptr;

    //! ledger_entries::base::const_row - a reference to a constant row in the \c temptbl_ledger_entriestable

    typedef x::const_ref<rowObj> const_row;

    //! ledger_entries::base::const_rowptr - a nullable pointer reference to a constant row in the \c temptbl_ledger_entriestable

    typedef x::const_ptr<rowObj> const_rowptr;

//! ledger_entries::base::iterator - Iterator returned by begin() and end() 

    typedef x::refiterator<iteratorObj> iterator;

//! ledger_entries::base::iteratorptr - Nullable iterator value returned by begin() and end()

    typedef x::ptriterator<iteratorObj> iteratorptr;

//! ledger_entries::base::const_iterator - Constant iterator value returned by begin() and end()

    typedef x::const_refiterator<iteratorObj> const_iterator;

//! ledger_entries::base::const_iteratorptr - Nullable iterator value returned by begin() and end() 

    typedef x::const_ptriterator<iteratorObj> const_iteratorptr;

    //! ledger_entries::base::joins - a reference to joins from the \c temptbl_ledger_entriestable

    typedef x::ref<ledger_entries_JoinsObj> joins;

    //! ledger_entries::base::joinsptr - a nullable pointer reference to joins from the \c temptbl_ledger_entriestable

    typedef x::ptr<ledger_entries_JoinsObj> joinsptr;

    //! ledger_entries::base::const_joins - a reference to constant joins from the \c temptbl_ledger_entriestable

    typedef x::const_ref<ledger_entries_JoinsObj> const_joins;

    //! ledger_entries::base::const_joinsptr - a nullable pointer reference to constant joins from the \c temptbl_ledger_entriestable

    typedef x::const_ptr<ledger_entries_JoinsObj> const_joinsptr;

    //! A reference to a prefetched row.

    typedef x::ref<prefetchedrowObj> prefetchedrow;

    //! A nullable pointer reference to a prefetched row.

    typedef x::ptr<prefetchedrowObj> prefetchedrowptr;

    //! A reference to a constant prefetched row.

    typedef x::const_ref<prefetchedrowObj> const_prefetchedrow;

    //! A nullable pointer reference to a constant prefetched row.

    typedef x::ptr<prefetchedrowObj> const_prefetchedrowptr;
};

//! Joins for the \c accounts resultset object

class accounts_JoinsObj : public x::sql::dbi::joinBaseObj {

public:

    //! The table columns

    static const char * const columns[];

    //! Return table columns

    const char * const *get_table_columns() const override;

    

    //! Constructor

    accounts_JoinsObj();

    //! Destructor

    ~accounts_JoinsObj() noexcept;


    //! Create a join to the ledger_entries table on columns: account_id
    virtual ledger_entries::base::joins join_ledger_entries()=0;


    //! Prefetch rows from this join

    accounts::base::prefetchedrow prefetch();

private:

    //! Return the connection object that was used to create this join.

    //! Used by prefetch() to retrieve the connection object from the subclass
    //! so that it can instantiated the prefetchedrow object.

    virtual x::sql::connection getConnection()=0;
};

//! The \c accounts resultset object

class accountsObj : public x::sql::dbi::resultsetObj, public accounts_JoinsObj {

//! The table alias in the resultset

    std::string alias;

public:

    //! Resultset constructor

    accountsObj(const x::sql::connection &conn);

    //! Additional resultset constructed by a join

    accountsObj(const x::sql::connection &conn, const x::ref<aliasesObj> &aliasesArg);

    //! Destructor
    
    ~accountsObj() noexcept;

private:
    //! This table's name

    static const char table_name[];

public:
    //! Return this table's name;

    const char *get_table_name() const override;

    //! This table's alias

    std::string get_table_alias() const override;

    //! Table's primary keys

    static const char * const primarykeycolumns[];

    //! Return table's primary key columns

    const char * const *get_primary_key_columns() const override;

    //! Table's serial keys

    static const char * const serialkeycolumns[];

    //! Return table's serial primary key column(s)

    const char * const *get_serial_key_columns() const override;

    friend class accountsBase::rowObj;

    friend class accountsBase::iteratorObj;

    //! Convenience typedef

    typedef accountsBase::iterator iterator;

    //! Convenience typedef

    typedef accountsBase::iteratorptr iteratorptr;

    //! Convenience typedef

    typedef accountsBase::const_iterator const_iterator;

    //! Convenience typedef

    typedef accountsBase::const_iteratorptr const_iteratorptr;

    //! Convenience typedef

    typedef accountsBase::row row;

    //! Convenience typedef

    typedef accountsBase::rowptr rowptr;

    //! Convenience typedef

    typedef accountsBase::const_row const_row;

    //! Convenience typedef

    typedef accountsBase::const_rowptr const_rowptr;

    //! Execute a SELECT on this resultset, return the beginning iterator for the sequence.

    //! The maximum number of rows is set by calling limit(), previously.
    iterator begin() const;

    //! Execute a SELECT on this resultset, return the beginning iterator for the sequence.

    //! The maximum number of rows is given explicitly
    iterator begin(size_t limitvalue) const;

    //! Return ending iterator value for a SELECT sequence

    iterator end() const;

    //! Return the sole row possibly expected from a SELECT on this resultset.

    //! Uses begin(2), and throws an exception if the SELECT returns a second
    //! row. Returns a null pointer reference if SELECT returned no rows.

    rowptr maybe() const;

    //! Return the sole row definitely expected from a SELECT on this resultset.

    //! Calls maybe(), and throws an exception if maybe() returns an empty
    //! pointer.

    row only() const;

private:

    //! Resultset implementation subclass forwards this to its create_column_list()

    void resultset_create_column_list(std::vector<std::string> &columns) const override;

    //! Add additional joins to the resultset

    //! Used by get_search_sql() to recursively add joins to joins.

    void get_join_sql_recursive(std::ostream &) const override;

    //! Invoke join_prefetch_column_list()

    void prefetch_column_list_recursive(std::vector<std::string> &list) const override;

    //! Invoke join_bind_prefetched_row()
    void bind_prefetched_recursive(std::vector<x::sql::bindrowimpl> &list) const override;
public:

    //! Used by prefetch() to retrieve the connection object.

    x::sql::connection getConnection() override;

    //! Insert a new row

    template<typename ...Args>
    inline row insert(Args && ...args)
    {
        auto rs=accounts::create(conn);

	auto insert_constraints=x::ref<x::sql::dbi::constraintObj::andObj>::create();

        {
            auto values=x::ref<x::sql::dbi::constraintObj::andObj>::create();

            x::sql::dbi::get_updins_list(values, std::forward<Args>(args)...);

            do_insert(rs->insert_sql, insert_constraints, rs->where, values);
        }

	rs->insert_select_constraint=insert_constraints;
        return rs->only();
    }


    //! Create a join to the ledger_entries table on columns: account_id
    ledger_entries::base::joins join_ledger_entries() override;

};

//! A reference-counted object representing a row in this table

class accountsBase::rowObj : public x::sql::dbi::resultsetObj::rowObj {

public:

    friend class iteratorObj;

    //! Constructor

    rowObj(const x::sql::connection &conn);

    //! Destructor

    ~rowObj() noexcept;

//! Column

    x::sql::dbi::resultsetObj::rowObj::field<int64_t> account_id;

//! Column

    x::sql::dbi::resultsetObj::rowObj::field<std::string> code;


    //! Create a new resultset based on a join to the ledger_entries table on columns: account_id
    ledger_entries join_rs_ledger_entries() const;

    //! Retrieve the only row possibly expected from a join to the ledger_entries table on columns: account_id

    ledger_entries::base::rowptr join_maybe_ledger_entries() const;

    //! Retrieve the only row definitely from a join to the ledger_entries table on columns: account_id

    ledger_entries::base::row join_only_ledger_entries() const;

      //! Execute the join to the ledger_entries table on columns: account_id

    inline ledger_entries join_ledger_entries() const
    {
        return join_rs_ledger_entries();
    }

private:

    //! Cached joined row

    mutable x::sql::dbi::resultsetObj::rowObj::cached_row<ledger_entries::base::rowptr> join_row_ledger_entries;

public:


    //! Update this row

    //! Returns true if the row was updated, false if the row was unchanged.
    //! An exception gets thrown if the schema's primary keys are wrong.

    bool update() override;

    friend class accountsBase::prefetchedrowObj;

private:
    //! This row has been fetched. Preserve all .scalar in .original

    void fetched_this_row();
};

//! A new row factory, used by iteratorObj to create new rows.

//! Also returned by join handles' prefetch(), where a prefetched row may be
//! retrieved from.

class accountsBase::prefetchedrowObj : public x::sql::bindrowimplObj {

    //! Our omniscient connection

    x::sql::connection conn;

    //! The next row being fetched

    accounts::base::row next_row;

    //! Whether next_row has been used, or not.

    //! The constructor creates a new next_row. First call to bind() uses
    //! it, subsequent calls create a new next_row.

    bool first;

public:

    //! Current row

    accounts::base::row row;

    friend class iteratorObj;

    friend class accounts_JoinObj;

public:
    //! Constructor
    prefetchedrowObj(const x::sql::connection &connArg);

    //! Destructor
    ~prefetchedrowObj() noexcept;

private:

    //! Bind next row
    void bind(x::sql::bindrow::consecutive &factory) override;

    //! The row was fetched
    void fetched() override;
};


//! A reference-counted iterator object, over the resultset

class accountsBase::iteratorObj : virtual public x::obj {

    //! Current row

    x::ref<accounts::base::prefetchedrowObj> current_row;

    //! All rows, this one and any prefetched ones.

    x::sql::dbi::resultsetObj::bindrow_all all_rows;

    //! The executed SELECT statement

    x::sql::statementptr statement;

    //! The resultset this iterator came from

    
    const_accounts resultset;

public:
    friend class accountsObj;

    //! This is an input iterator

    typedef std::input_iterator_tag iterator_category;

    //! What this is iterating over

    typedef accounts::base::row value_type;

    //! Iterator trait
    typedef std::ptrdiff_t difference_type;

    //! Iterator trait
    typedef value_type *pointer;

    //! Iterator trait
    typedef value_type &reference;

public:
    //! Beginning iterator constructor

    //! The resultset's begin() create()s this object using this constructor.
    //! We get the executed statement object, and the resultset that created
    //! this iterator.

    iteratorObj(const x::sql::statement &statementArg, const const_accounts &resultsetArg);

    //! Ending iterator constructor

    //! The resultset's end() create()s this object using this constructor.

    iteratorObj(const 
    const_accounts &resultsetArg);

    //! Destructor

    ~iteratorObj() noexcept;

    //! The * operator

    inline const accounts::base::row &operator*() const
    {
        *statement; // Ending iterator value check.
        return current_row->row;
    }

    //! Fetch next row

    void operator++()
    {
        if (!statement->fetch(all_rows))
        {
            // No more rows
            statement=x::sql::statementptr();
            return;
        }

        for (const auto &row:all_rows.rows)
            row->fetched();
    }

    //! Two ending iterator values compare equal, anything else doesn't

    inline bool operator==(const iteratorObj &o) const
    {
        return statement.null() && o.statement.null();
    }

    //! Two ending iterator values compare equal, anything else doesn't

    inline bool operator!=(const iteratorObj &o) const
    {
        return !operator==(o);
    }

private:

    //! Helper class used by before_postoper()
    class postoper_helper {

        //! Saved row

        accounts::base::row saved_row;

    public:
        //! Constructor
        inline postoper_helper(const accounts::base::row & saved_rowArg) : saved_row(saved_rowArg) {}

        
        inline accounts::base::row operator*() const { return saved_row; }
    };

public:
    //! Called by refobjiterator's postfix++ before it calls my operator++()

    postoper_helper before_postoper();
};

//! Joins for the \c transactions resultset object

class transactions_JoinsObj : public x::sql::dbi::joinBaseObj {

public:

    //! The table columns

    static const char * const columns[];

    //! Return table columns

    const char * const *get_table_columns() const override;

    

    //! Constructor

    transactions_JoinsObj();

    //! Destructor

    ~transactions_JoinsObj() noexcept;


    //! Create a join to the ledger_entries table on columns: transaction_id
    virtual ledger_entries::base::joins join_ledger_entries()=0;


    //! Prefetch rows from this join

    transactions::base::prefetchedrow prefetch();

private:

    //! Return the connection object that was used to create this join.

    //! Used by prefetch() to retrieve the connection object from the subclass
    //! so that it can instantiated the prefetchedrow object.

    virtual x::sql::connection getConnection()=0;
};

//! The \c transactions resultset object

class transactionsObj : public x::sql::dbi::resultsetObj, public transactions_JoinsObj {

//! The table alias in the resultset

    std::string alias;

public:

    //! Resultset constructor

    transactionsObj(const x::sql::connection &conn);

    //! Additional resultset constructed by a join

    transactionsObj(const x::sql::connection &conn, const x::ref<aliasesObj> &aliasesArg);

    //! Destructor
    
    ~transactionsObj() noexcept;

private:
    //! This table's name

    static const char table_name[];

public:
    //! Return this table's name;

    const char *get_table_name() const override;

    //! This table's alias

    std::string get_table_alias() const override;

    //! Table's primary keys

    static const char * const primarykeycolumns[];

    //! Return table's primary key columns

    const char * const *get_primary_key_columns() const override;

    //! Table's serial keys

    static const char * const serialkeycolumns[];

    //! Return table's serial primary key column(s)

    const char * const *get_serial_key_columns() const override;

    friend class transactionsBase::rowObj;

    friend class transactionsBase::iteratorObj;

    //! Convenience typedef

    typedef transactionsBase::iterator iterator;

    //! Convenience typedef

    typedef transactionsBase::iteratorptr iteratorptr;

    //! Convenience typedef

    typedef transactionsBase::const_iterator const_iterator;

    //! Convenience typedef

    typedef transactionsBase::const_iteratorptr const_iteratorptr;

    //! Convenience typedef

    typedef transactionsBase::row row;

    //! Convenience typedef

    typedef transactionsBase::rowptr rowptr;

    //! Convenience typedef

    typedef transactionsBase::const_row const_row;

    //! Convenience typedef

    typedef transactionsBase::const_rowptr const_rowptr;

    //! Execute a SELECT on this resultset, return the beginning iterator for the sequence.

    //! The maximum number of rows is set by calling limit(), previously.
    iterator begin() const;

    //! Execute a SELECT on this resultset, return the beginning iterator for the sequence.

    //! The maximum number of rows is given explicitly
    iterator begin(size_t limitvalue) const;

    //! Return ending iterator value for a SELECT sequence

    iterator end() const;

    //! Return the sole row possibly expected from a SELECT on this resultset.

    //! Uses begin(2), and throws an exception if the SELECT returns a second
    //! row. Returns a null pointer reference if SELECT returned no rows.

    rowptr maybe() const;

    //! Return the sole row definitely expected from a SELECT on this resultset.

    //! Calls maybe(), and throws an exception if maybe() returns an empty
    //! pointer.

    row only() const;

private:

    //! Resultset implementation subclass forwards this to its create_column_list()

    void resultset_create_column_list(std::vector<std::string> &columns) const override;

    //! Add additional joins to the resultset

    //! Used by get_search_sql() to recursively add joins to joins.

    void get_join_sql_recursive(std::ostream &) const override;

    //! Invoke join_prefetch_column_list()

    void prefetch_column_list_recursive(std::vector<std::string> &list) const override;

    //! Invoke join_bind_prefetched_row()
    void bind_prefetched_recursive(std::vector<x::sql::bindrowimpl> &list) const override;
public:

    //! Used by prefetch() to retrieve the connection object.

    x::sql::connection getConnection() override;

    //! Insert a new row

    template<typename ...Args>
    inline row insert(Args && ...args)
    {
        auto rs=transactions::create(conn);

	auto insert_constraints=x::ref<x::sql::dbi::constraintObj::andObj>::create();

        {
            auto values=x::ref<x::sql::dbi::constraintObj::andObj>::create();

            x::sql::dbi::get_updins_list(values, std::forward<Args>(args)...);

            do_insert(rs->insert_sql, insert_constraints, rs->where, values);
        }

	rs->insert_select_constraint=insert_constraints;
        return rs->only();
    }


    //! Create a join to the ledger_entries table on columns: transaction_id
    ledger_entries::base::joins join_ledger_entries() override;

};

//! A reference-counted object representing a row in this table

class transactionsBase::rowObj : public x::sql::dbi::resultsetObj::rowObj {

public:

    friend class iteratorObj;

    //! Constructor

    rowObj(const x::sql::connection &conn);

    //! Destructor

    ~rowObj() noexcept;

//! Column

    x::sql::dbi::resultsetObj::rowObj::field<int64_t> transaction_id;


    //! Create a new resultset based on a join to the ledger_entries table on columns: transaction_id
    ledger_entries join_rs_ledger_entries() const;

    //! Retrieve the only row possibly expected from a join to the ledger_entries table on columns: transaction_id

    ledger_entries::base::rowptr join_maybe_ledger_entries() const;

    //! Retrieve the only row definitely from a join to the ledger_entries table on columns: transaction_id

    ledger_entries::base::row join_only_ledger_entries() const;

      //! Execute the join to the ledger_entries table on columns: transaction_id

    inline ledger_entries join_ledger_entries() const
    {
        return join_rs_ledger_entries();
    }

private:

    //! Cached joined row

    mutable x::sql::dbi::resultsetObj::rowObj::cached_row<ledger_entries::base::rowptr> join_row_ledger_entries;

public:


    //! Update this row

    //! Returns true if the row was updated, false if the row was unchanged.
    //! An exception gets thrown if the schema's primary keys are wrong.

    bool update() override;

    friend class transactionsBase::prefetchedrowObj;

private:
    //! This row has been fetched. Preserve all .scalar in .original

    void fetched_this_row();
};

//! A new row factory, used by iteratorObj to create new rows.

//! Also returned by join handles' prefetch(), where a prefetched row may be
//! retrieved from.

class transactionsBase::prefetchedrowObj : public x::sql::bindrowimplObj {

    //! Our omniscient connection

    x::sql::connection conn;

    //! The next row being fetched

    transactions::base::row next_row;

    //! Whether next_row has been used, or not.

    //! The constructor creates a new next_row. First call to bind() uses
    //! it, subsequent calls create a new next_row.

    bool first;

public:

    //! Current row

    transactions::base::row row;

    friend class iteratorObj;

    friend class transactions_JoinObj;

public:
    //! Constructor
    prefetchedrowObj(const x::sql::connection &connArg);

    //! Destructor
    ~prefetchedrowObj() noexcept;

private:

    //! Bind next row
    void bind(x::sql::bindrow::consecutive &factory) override;

    //! The row was fetched
    void fetched() override;
};


//! A reference-counted iterator object, over the resultset

class transactionsBase::iteratorObj : virtual public x::obj {

    //! Current row

    x::ref<transactions::base::prefetchedrowObj> current_row;

    //! All rows, this one and any prefetched ones.

    x::sql::dbi::resultsetObj::bindrow_all all_rows;

    //! The executed SELECT statement

    x::sql::statementptr statement;

    //! The resultset this iterator came from

    
    const_transactions resultset;

public:
    friend class transactionsObj;

    //! This is an input iterator

    typedef std::input_iterator_tag iterator_category;

    //! What this is iterating over

    typedef transactions::base::row value_type;

    //! Iterator trait
    typedef std::ptrdiff_t difference_type;

    //! Iterator trait
    typedef value_type *pointer;

    //! Iterator trait
    typedef value_type &reference;

public:
    //! Beginning iterator constructor

    //! The resultset's begin() create()s this object using this constructor.
    //! We get the executed statement object, and the resultset that created
    //! this iterator.

    iteratorObj(const x::sql::statement &statementArg, const const_transactions &resultsetArg);

    //! Ending iterator constructor

    //! The resultset's end() create()s this object using this constructor.

    iteratorObj(const 
    const_transactions &resultsetArg);

    //! Destructor

    ~iteratorObj() noexcept;

    //! The * operator

    inline const transactions::base::row &operator*() const
    {
        *statement; // Ending iterator value check.
        return current_row->row;
    }

    //! Fetch next row

    void operator++()
    {
        if (!statement->fetch(all_rows))
        {
            // No more rows
            statement=x::sql::statementptr();
            return;
        }

        for (const auto &row:all_rows.rows)
            row->fetched();
    }

    //! Two ending iterator values compare equal, anything else doesn't

    inline bool operator==(const iteratorObj &o) const
    {
        return statement.null() && o.statement.null();
    }

    //! Two ending iterator values compare equal, anything else doesn't

    inline bool operator!=(const iteratorObj &o) const
    {
        return !operator==(o);
    }

private:

    //! Helper class used by before_postoper()
    class postoper_helper {

        //! Saved row

        transactions::base::row saved_row;

    public:
        //! Constructor
        inline postoper_helper(const transactions::base::row & saved_rowArg) : saved_row(saved_rowArg) {}

        
        inline transactions::base::row operator*() const { return saved_row; }
    };

public:
    //! Called by refobjiterator's postfix++ before it calls my operator++()

    postoper_helper before_postoper();
};

//! Joins for the \c ledger_entries resultset object

class ledger_entries_JoinsObj : public x::sql::dbi::joinBaseObj {

public:

    //! The table columns

    static const char * const columns[];

    //! Return table columns

    const char * const *get_table_columns() const override;

    

    //! Constructor

    ledger_entries_JoinsObj();

    //! Destructor

    ~ledger_entries_JoinsObj() noexcept;


    //! Create a join to the accounts table on columns: account_id
    virtual accounts::base::joins join_accounts()=0;


    //! Create a join to the transactions table on columns: transaction_id
    virtual transactions::base::joins join_transactions()=0;


    //! Prefetch rows from this join

    ledger_entries::base::prefetchedrow prefetch();

private:

    //! Return the connection object that was used to create this join.

    //! Used by prefetch() to retrieve the connection object from the subclass
    //! so that it can instantiated the prefetchedrow object.

    virtual x::sql::connection getConnection()=0;
};

//! The \c ledger_entries resultset object

class ledger_entriesObj : public x::sql::dbi::resultsetObj, public ledger_entries_JoinsObj {

//! The table alias in the resultset

    std::string alias;

public:

    //! Resultset constructor

    ledger_entriesObj(const x::sql::connection &conn);

    //! Additional resultset constructed by a join

    ledger_entriesObj(const x::sql::connection &conn, const x::ref<aliasesObj> &aliasesArg);

    //! Destructor
    
    ~ledger_entriesObj() noexcept;

private:
    //! This table's name

    static const char table_name[];

public:
    //! Return this table's name;

    const char *get_table_name() const override;

    //! This table's alias

    std::string get_table_alias() const override;

    //! Table's primary keys

    static const char * const primarykeycolumns[];

    //! Return table's primary key columns

    const char * const *get_primary_key_columns() const override;

    //! Table's serial keys

    static const char * const serialkeycolumns[];

    //! Return table's serial primary key column(s)

    const char * const *get_serial_key_columns() const override;

    friend class ledger_entriesBase::rowObj;

    friend class ledger_entriesBase::iteratorObj;

    //! Convenience typedef

    typedef ledger_entriesBase::iterator iterator;

    //! Convenience typedef

    typedef ledger_entriesBase::iteratorptr iteratorptr;

    //! Convenience typedef

    typedef ledger_entriesBase::const_iterator const_iterator;

    //! Convenience typedef

    typedef ledger_entriesBase::const_iteratorptr const_iteratorptr;

    //! Convenience typedef

    typedef ledger_entriesBase::row row;

    //! Convenience typedef

    typedef ledger_entriesBase::rowptr rowptr;

    //! Convenience typedef

    typedef ledger_entriesBase::const_row const_row;

    //! Convenience typedef

    typedef ledger_entriesBase::const_rowptr const_rowptr;

    //! Execute a SELECT on this resultset, return the beginning iterator for the sequence.

    //! The maximum number of rows is set by calling limit(), previously.
    iterator begin() const;

    //! Execute a SELECT on this resultset, return the beginning iterator for the sequence.

    //! The maximum number of rows is given explicitly
    iterator begin(size_t limitvalue) const;

    //! Return ending iterator value for a SELECT sequence

    iterator end() const;

    //! Return the sole row possibly expected from a SELECT on this resultset.

    //! Uses begin(2), and throws an exception if the SELECT returns a second
    //! row. Returns a null pointer reference if SELECT returned no rows.

    rowptr maybe() const;

    //! Return the sole row definitely expected from a SELECT on this resultset.

    //! Calls maybe(), and throws an exception if maybe() returns an empty
    //! pointer.

    row only() const;

private:

    //! Resultset implementation subclass forwards this to its create_column_list()

    void resultset_create_column_list(std::vector<std::string> &columns) const override;

    //! Add additional joins to the resultset

    //! Used by get_search_sql() to recursively add joins to joins.

    void get_join_sql_recursive(std::ostream &) const override;

    //! Invoke join_prefetch_column_list()

    void prefetch_column_list_recursive(std::vector<std::string> &list) const override;

    //! Invoke join_bind_prefetched_row()
    void bind_prefetched_recursive(std::vector<x::sql::bindrowimpl> &list) const override;
public:

    //! Used by prefetch() to retrieve the connection object.

    x::sql::connection getConnection() override;

    //! Insert a new row

    template<typename ...Args>
    inline row insert(Args && ...args)
    {
        auto rs=ledger_entries::create(conn);

	auto insert_constraints=x::ref<x::sql::dbi::constraintObj::andObj>::create();

        {
            auto values=x::ref<x::sql::dbi::constraintObj::andObj>::create();

            x::sql::dbi::get_updins_list(values, std::forward<Args>(args)...);

            do_insert(rs->insert_sql, insert_constraints, rs->where, values);
        }

	rs->insert_select_constraint=insert_constraints;
        return rs->only();
    }


    //! Create a join to the accounts table on columns: account_id
    accounts::base::joins join_accounts() override;


    //! Create a join to the transactions table on columns: transaction_id
    transactions::base::joins join_transactions() override;

};

//! A reference-counted object representing a row in this table

class ledger_entriesBase::rowObj : public x::sql::dbi::resultsetObj::rowObj {

public:

    friend class iteratorObj;

    //! Constructor

    rowObj(const x::sql::connection &conn);

    //! Destructor

    ~rowObj() noexcept;

//! Column

    x::sql::dbi::resultsetObj::rowObj::field<int64_t> ledger_entry_id;

//! Column

    x::sql::dbi::resultsetObj::rowObj::field<int64_t> account_id;

//! Column

    x::sql::dbi::resultsetObj::rowObj::field<int64_t> transaction_id;

//! Column

    x::sql::dbi::resultsetObj::rowObj::field<x::ymd> ledger_date;

//! Column

    x::sql::dbi::resultsetObj::rowObj::field<double> amount;


    //! Create a new resultset based on a join to the accounts table on columns: account_id
    accounts join_rs_accounts() const;

    //! Retrieve the only row possibly expected from a join to the accounts table on columns: account_id

    accounts::base::rowptr join_maybe_accounts() const;

    //! Retrieve the only row definitely from a join to the accounts table on columns: account_id

    accounts::base::row join_only_accounts() const;

      //! Execute the join to the accounts table on columns: account_id

    inline accounts::base::row join_accounts() const
    {
        return join_only_accounts();
    }

private:

    //! Cached joined row

    mutable x::sql::dbi::resultsetObj::rowObj::cached_row<accounts::base::rowptr> join_row_accounts;

public:


    //! Create a new resultset based on a join to the transactions table on columns: transaction_id
    transactions join_rs_transactions() const;

    //! Retrieve the only row possibly expected from a join to the transactions table on columns: transaction_id

    transactions::base::rowptr join_maybe_transactions() const;

    //! Retrieve the only row definitely from a join to the transactions table on columns: transaction_id

    transactions::base::row join_only_transactions() const;

      //! Execute the join to the transactions table on columns: transaction_id

    inline transactions::base::row join_transactions() const
    {
        return join_only_transactions();
    }

private:

    //! Cached joined row

    mutable x::sql::dbi::resultsetObj::rowObj::cached_row<transactions::base::rowptr> join_row_transactions;

public:


    //! Update this row

    //! Returns true if the row was updated, false if the row was unchanged.
    //! An exception gets thrown if the schema's primary keys are wrong.

    bool update() override;

    friend class ledger_entriesBase::prefetchedrowObj;

private:
    //! This row has been fetched. Preserve all .scalar in .original

    void fetched_this_row();
};

//! A new row factory, used by iteratorObj to create new rows.

//! Also returned by join handles' prefetch(), where a prefetched row may be
//! retrieved from.

class ledger_entriesBase::prefetchedrowObj : public x::sql::bindrowimplObj {

    //! Our omniscient connection

    x::sql::connection conn;

    //! The next row being fetched

    ledger_entries::base::row next_row;

    //! Whether next_row has been used, or not.

    //! The constructor creates a new next_row. First call to bind() uses
    //! it, subsequent calls create a new next_row.

    bool first;

public:

    //! Current row

    ledger_entries::base::row row;

    friend class iteratorObj;

    friend class ledger_entries_JoinObj;

public:
    //! Constructor
    prefetchedrowObj(const x::sql::connection &connArg);

    //! Destructor
    ~prefetchedrowObj() noexcept;

private:

    //! Bind next row
    void bind(x::sql::bindrow::consecutive &factory) override;

    //! The row was fetched
    void fetched() override;
};


//! A reference-counted iterator object, over the resultset

class ledger_entriesBase::iteratorObj : virtual public x::obj {

    //! Current row

    x::ref<ledger_entries::base::prefetchedrowObj> current_row;

    //! All rows, this one and any prefetched ones.

    x::sql::dbi::resultsetObj::bindrow_all all_rows;

    //! The executed SELECT statement

    x::sql::statementptr statement;

    //! The resultset this iterator came from

    
    const_ledger_entries resultset;

public:
    friend class ledger_entriesObj;

    //! This is an input iterator

    typedef std::input_iterator_tag iterator_category;

    //! What this is iterating over

    typedef ledger_entries::base::row value_type;

    //! Iterator trait
    typedef std::ptrdiff_t difference_type;

    //! Iterator trait
    typedef value_type *pointer;

    //! Iterator trait
    typedef value_type &reference;

public:
    //! Beginning iterator constructor

    //! The resultset's begin() create()s this object using this constructor.
    //! We get the executed statement object, and the resultset that created
    //! this iterator.

    iteratorObj(const x::sql::statement &statementArg, const const_ledger_entries &resultsetArg);

    //! Ending iterator constructor

    //! The resultset's end() create()s this object using this constructor.

    iteratorObj(const 
    const_ledger_entries &resultsetArg);

    //! Destructor

    ~iteratorObj() noexcept;

    //! The * operator

    inline const ledger_entries::base::row &operator*() const
    {
        *statement; // Ending iterator value check.
        return current_row->row;
    }

    //! Fetch next row

    void operator++()
    {
        if (!statement->fetch(all_rows))
        {
            // No more rows
            statement=x::sql::statementptr();
            return;
        }

        for (const auto &row:all_rows.rows)
            row->fetched();
    }

    //! Two ending iterator values compare equal, anything else doesn't

    inline bool operator==(const iteratorObj &o) const
    {
        return statement.null() && o.statement.null();
    }

    //! Two ending iterator values compare equal, anything else doesn't

    inline bool operator!=(const iteratorObj &o) const
    {
        return !operator==(o);
    }

private:

    //! Helper class used by before_postoper()
    class postoper_helper {

        //! Saved row

        ledger_entries::base::row saved_row;

    public:
        //! Constructor
        inline postoper_helper(const ledger_entries::base::row & saved_rowArg) : saved_row(saved_rowArg) {}

        
        inline ledger_entries::base::row operator*() const { return saved_row; }
    };

public:
    //! Called by refobjiterator's postfix++ before it calls my operator++()

    postoper_helper before_postoper();
};

};
